class Validator {
  static isLetterOrEqual(n, maxValue) {
    return +n <= +maxValue;
  }

  static isGreaterOrEqual(n, minValue) {
    return +n >= +minValue;
  }

  static isCorrectFloat(n, unsigned, intPartMaxLen, floatPartMaxLen) {
    const reFloatUnsigned = new RegExp(`\\d{1,${intPartMaxLen}}(\\.\\d{0,${floatPartMaxLen}})?$`, 'g');
    const reFloatSigned = new RegExp(`^-?\\d{1,${intPartMaxLen}}(\\.\\d{0,${floatPartMaxLen}})?$`, 'g');

    let regExpToUse = '';

    if (unsigned) {
      regExpToUse = reFloatUnsigned;
    } else {
      regExpToUse = reFloatSigned;
    }

    const matches = String(n).match(regExpToUse);

    if (matches) {
      return String(matches[0]) === String(n);
    }
    return false;
  }

  static isCorrectInteger(n, unsigned, maxLen) {
    const reIntegerUnsigned = new RegExp(`^(\\d){1,${maxLen}}$`, 'g');
    const reIntegerSigned = new RegExp(`^-?(\\d){1,${maxLen}}$`, 'g');

    let regExpToUse = '';

    if (unsigned) {
      regExpToUse = reIntegerUnsigned;
    } else {
      regExpToUse = reIntegerSigned;
    }

    const matches = String(n).match(regExpToUse);

    if (matches) {
      return String(matches[0]) === String(n);
    }
    return false;
  }
}

export default Validator;
